

Device 18F45K22
Xtal 64


    
Config_Start
   FOSC = HSMP ; HS oscillator (high power > 16 MHz)
   PLLCFG = On ; Oscillator multiplied by 4
   PRICLKEN = On ; Primary clock is always enabled
   FCMEN = OFF ; Fail-Safe Clock Monitor disabled
   IESO = OFF ; Oscillator Switchover mode disabled
   PWRTEN = OFF ; Power up timer disabled
   BOREN = OFF ; Brown-out Reset disabled in hardware and software
   WDTEN = OFF ; Watch dog timer is always disabled. SWDTEN has no effect.
   PBADEN = OFF ; PORTB<5:0> pins are configured as digital I/O on Reset
   HFOFST = OFF ; HFINTOSC output and ready status are delayed by the oscillator stable status
   MCLRE = EXTMCLR ; MCLR pin enabled, RE3 input pin disabled
   STVREN = OFF ; Stack full/underflow will not cause Reset
   XINST = OFF ; Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
   Debug = OFF ; Disabled
   CP0 = OFF ; Block 0 (000800-001FFFh) not code-protected
   CP1 = OFF ; Block 1 (002000-003FFFh) not code-protected
   CP2 = OFF ; Block 2 (004000-005FFFh) not code-protected
   CP3 = OFF ; Block 3 (006000-007FFFh) not code-protected
   CPB = OFF ; Boot block (000000-0007FFh) not code-protected
   CPD = OFF ; Data EEPROM not code-protected
   WRT0 = OFF ; Block 0 (000800-001FFFh) not write-protected
   WRT1 = OFF ; Block 1 (002000-003FFFh) not write-protected
   WRT2 = OFF ; Block 2 (004000-005FFFh) not write-protected
   WRT3 = OFF ; Block 3 (006000-007FFFh) not write-protected
   WRTC = OFF ; Configuration registers (300000-3000FFh) not write-protected
   WRTB = OFF ; Boot Block (000000-0007FFh) write-protected
   WRTD = OFF ; Data EEPROM not write-protected
   EBTR0 = OFF ; Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
   EBTR1 = OFF ; Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
   EBTR2 = OFF ; Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
   EBTR3 = OFF ; Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
   EBTRB = OFF ; Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End

    Symbol SERIAL_RX = PORTC.7    
    Symbol SERIAL_TX = PORTC.6

    Declare Hserial_Clear On
    Declare Hserial_Baud 115200 ' 57600  ' Cannot use BAUD rates lower than this with these XTAL/CLOCK/PLL speeds !!!!
    Declare Hserial_TXSTA = $24
    Declare Hserial_RCSTA = $90
    
    
    Dim bBit                As Bit 
    Dim bTemp               As Bit

    Dim lRegisterValue      As Word

    Dim nLSN                As Byte 
    Dim nMSN                As Byte 

 
        ' Setup the values that were read from various routines       
                              '  16             0
        lRegisterValue = $0A  ' %0000000000001010
        nLSN = 0

        ' Original code here                
        bBit = nLSN.3 ' What are we looking for (nLSN = 0, so nLSN.3 should = 0, so bBit should also now = 0)
        nLSN.3 = 0 ' Clear the NOT bit ' We force bit 3 to 0 so we can ONLY use bits 0 to 2 as the index for the GetBit   
        
        bTemp = GetBit lRegisterValue.Byte0, nLSN           
        ' lRegisterValue.Byte0 should = %00001010 and so bit 0 should = 0
                
        HRSOut "   Reg Value:", Hex4 lRegisterValue.Byte0, 13, 10  ' = %00001010
        HRSOut "    Test Bit:  ", Hex2 nLSN, 13, 10                ' = 0
        HRSOut " Looking For:  ", Hex2 bBit, 13, 10                ' = 0
        HRSOut "       Found:  ", Hex2 bTemp, 13, 10               ' = 0
                        
        If bBit = bTemp Then ' Since bBit (0) = bTemp (0) the text "JMP REQUIRED" should be output
            ' Perform Jump
            HRSOut ">> JMP REQUIRED", 13, 10
        Else
            HRSOut "FAILED AGAIN", 13, 10    '---- YET WE GET THIS !!!!        
        End If

        If bBit = 0 Then 
            HRSOut "bBit = 0", 13, 10    ' Does indeed output 0
        End If
        
        If bTemp = 0 Then 
            HRSOut "bTemp = 0", 13, 10   ' Also outputs 0     
        End If
        
        HRSOut "Stopped", 13, 10
        
        Stop
        

